DEFine fn parse_input_not_ok%
rem this opens and parses the input file
rem (some of it already parsed when loading ctrl file)
rem returns 0 if no errors, else error - 101 is special error in extensions
rem
rem this sets the global variables
rem errfile$,output_file$,default_output_dir$,default_input_dir$
rem l_to_p$,p_to_l$
rem
rem also uses global vars endoption$ and endmarker$
rem
rem v. 1.03
local lp%,line$,inchan%,arr$(1,1)
local opt%,procedure_name$,in_procedure%,oldtpye$,type$
  inchan%=FOP_IN(in_file$)		: rem open lcf again
  if inchan%<0
    error_string$=in_file$
    unst
    print_error inchan%
    return inchan%
  endif
  pe_cls#scr_chan%
  pe_print#scr_chan%, info_message$(11) : rem say hello
  opt%=error_in_open_output_files%	: rem open all output files
  if opt%
    unst
    print_error opt%
    close#inchan%:return opt%
  end if
:					: rem check all extensions
  pe_cls#scr_chan%
  pe_print#scr_chan%,cr$&centr$(info_message$(12),warning_width%) : rem say check extensions
  if errors_in_extensions%
    error_string$=error_message$(18)
    show_errors 1
    return -101
  endif
:
  pe_cls#scr_chan%			: rem get input section
  pe_print#scr_chan%,cr$&centr$(info_message$(13),warning_width%)&cr$&centr$(output_file$,warning_width%)
  opt%=get_start_of_section%(startinput$,inchan%) : rem find input section now
  if not opt%
    error_string$=error_message$(19)
    show_errors 0
    return -101
  endif
:					: rem this is the main loop
  procedure_name$="(no proc or fn)"	: rem no procedure name yet
  in_procedure%=0			: rem we're not in a procedure yet
  type$="function"			: rem these are used by read_file_error%
  oldtype$=""
  header_is_set%=0
  dim myprocs$(50,50)
  proc_nbrs%=0				: rem no procs/fns yet
  line_number%=start_line%		: rem start with first line number
  rep lp%
    input#inchan%,my_file$		: rem get a filename from ctrl file
    line_in_file%=line_in_file%+1
    my_file$=exp_tabs$(my_file$,tab_spaces%) : rem expand tabs & strip spaces at ends
    if my_file$="":next lp%		: rem blank line?
    if my_file$==endinput$:exit lp%	: rem end of input?
    if my_file$==endmarker$:exit lp%	: rem end of file?
    opt%='/' instr my_file$
    if opt%=1:next lp%
    my_file$=my_file$(1 to opt%-1)	: rem strip off possible comment
    if read_file_error%( strip_spaces$(my_file$))
					: rem this does the work
      error_string$=error_message$(20)&cr$&line_number%
      show_errors 0
      return -101
    endif
    if eof(#inchan%):exit lp%	: rem do until end
  end rep lp%
  close_channels			: rem close all channels
  if proc_nbrs%
    dim arr$(proc_nbrs%,50)		: rem make temporay arry
    arrcopy myprocs$,arr$
    dim myprocs$(proc_nbrs%,50) 	: rem true number of procs
    arrcopy arr$,myprocs$
  endif
  myprocs$(0)='  '			: rem show that array is correctly filled in
  asort myprocs$,0
  opt%= check_errors%(errfile$) 	: rem any errors during read?
  if opt%
    unst
    error_string$=error_message$(21)
    print_error opt%
    return opt%
  endif
  return 0
END DEFine parse_input_not_ok%
:
def fn get_start_of_section%(section$,inchan%)
rem this finds the section section$, by reading from inchan%
rem returns 1 if section found (the file is positioned after the section start)
rem else 0
rem
rem v. 1.01
local lp%,a$
  put#inchan%\0 			: rem position at start of file
  line_in_file%=0
  rep lp%
    if eof(#inchan%):return 0		: rem oops, not found!
    input#inchan%,a$			: rem get string
    line_in_file%=line_in_file%+1
    a$=exp_tabs$(a$,tab_spaces%)	: rem also strips spaces at end
    if a$==section$:return 1		: rem is it my section?
  end rep lp%				: rem if no, go around again
end def get_start_of_section%
:
def proc show_errors (flag%)
  close_channels
  unst
  print_error 0
  if flag%
    mk_main_app 			: rem make appsubwindow with error reports
    ap_in main_defn,app_addr+180	: rem put the appsub definition in
    dr_wdrw main_defn			: rem and redraw the window
  endif
end def show_errors
:
def proc close_channels
  CLOSE#inchan%
  close#errfile%			: rem error when reading the source file
  CLOSE#procs_to_lines%
  CLOSE#lines_to_procs%
  CLOSE#output_file%			: rem read_file_error returns 1
  inchan%=0
  errfile%=0
  procs_to_lines%=0
  lines_to_procs%=0
  output_file%=0			: rem read_file_error returns 1
end def close_channels
:
