def fn errors_in_compiler_options%
rem this gets the compiler options contained in the linker control file
rem returns 0 if no error, else 1
rem
rem uses global vars subwinarra$,modulefile$,error_message$
rem v.1.02
local lp%,counter%,a$,is_eror%,mycomp_opt$
  dim subwinarray$(80,80),modulefile$(80,40),linenumber$(80,5)
  mycomp_opt$="NOWINDSNOBEEP AUTOF  DEBUG  NONAMESNOLINE STAT   RUN"
  counter%=1
  is_eror%=0				: rem no error until now
: rem first, reset to configured comp options
  DIM comp_options%(7)			: rem the compiler options
  for lp%=0 to 7:comp_options%(lp%)=(COMPOP(lp%+1))*12 : rem if 0 stays 0 else becomes 128, i.e. selected
  if not get_start_of_section%(startcompopt$,inchan%)
     return 0				: rem  no comp opts section in lnk file
  endif
  rep lp%
    if eof(#inchan%)
       subwinarray$(counter%)=make_length$(endcompopt$,39)&" : "&error_message$(7)
       return 1    : rem end of file without "**--end of compiler options-**"
    endif
    input#inchan%,a$			: rem get a line
    a$=exp_tabs$(a$,tab_spaces%)	: rem expand possible tabs
    line_in_file%=line_in_file%+1	: rem next line in file
    if a$==endcompopt$:return is_eror%	: rem leave if end of comp_opts
    if a$="":next lp%			: rem skip blank lines
    opt%="/" instr a$
    if opt%
      if opt%=1:next lp%		: rem if line is a comment
      a$=strip_spaces$(a$(1 to opt%-1)) : rem strip of comment now
    endif
    opt%=a$ instr mycomp_opt$		: rem line should be included here
    if not opt%
       subwinarray$(counter%)=make_length$(a$,39)&" : "&error_message$(29)
       modulefile$(counter%)=in_file$
       counter%=counter%+1		: rem if not recognized
       is_eror%=1
       next lp%
    else
      opt%=(opt%-1) div 7
      comp_options%(opt%)=128		: rem set compiler option now
    endif
  end rep lp%
end def errors_in_compiler_options%
:
