def fn errors_in_extensions%
rem this checks whether all extensions are loaded into job 0 now
rem returns 0 if no error, else 1
rem
rem uses global vars subwinarra$,modulefile$,error_message$
rem v.1.02
local lp%,counter%,a$,to_set$,to_set$,option$,is_eror%
  dim subwinarray$(80,80),modulefile$(80,40),linenumber$(80,5)
  counter%=1
  is_eror%=0			: rem no error until now
  if not get_start_of_section%(startextn$,inchan%)
     return 0			: rem all OK if no extension section....
  endif
  rep lp%
    if eof(#inchan%)
       subwinarray$(counter%)=make_length$(endextn$,39)&" : "&error_message$(7)
       return 1	   : rem if end of file without "**--end of extensions-**"
    endif
    input#inchan%,a$		: rem get a line
    a$=exp_tabs$(a$,tab_spaces%)	: rem expand possible tabs & strip spaces
    line_in_file%=line_in_file%+1
    if a$==endextn$:return is_eror%	: rem leave if end of extensions
    if a$="":next lp%		: rem skip blank lines
    opt%="/" instr a$
    if opt%
      if opt%=1:NEXT lp%		: REMark if line is a comment
      a$=strip_spaces$(a$(1 to opt%-1))  : rem strip of comment now
    endif
    opt%="="INSTR a$
    IF NOT opt%
       subwinarray$(counter%)=make_length$(a$,39)&" : "&error_message$(8)
       modulefile$(counter%)=in_file$
       counter%=counter%+1		: rem if no "=" in line!
       is_eror%=1
       next lp%
    endif
    to_set$=strip_spaces$(a$(1 TO opt%-1))
    if not (to_set$=='Extension')
       subwinarray$(counter%)=make_length$(to_set$,39)&" : "&error_message$(9)
       modulefile$(counter%)=in_file$
       linenumber$(counter%)=line_in_file%
       counter%=counter%+1
       is_eror%=1
       next lp%
    endif
    if opt%= len(a$):next lp% 	: rem line was just "extension ="
    option$=strip_spaces$(a$(opt%+1 TO LEN(a$)))
    if option$="":next lp%		: rem line was just "extension ="
    opt%=is_extn(option$)		: rem is this an extension?
    if not opt%
       subwinarray$(counter%)=make_length$(a$,39)&" : "&error_message$(10)
       modulefile$(counter%)=in_file$
       linenumber$(counter%)=line_in_file%
       counter%=counter%+1		: rem this extension was not found
       is_eror%=1
       next lp%
     endif
  end rep lp%
end def errors_in_extensions%
:
